#define NODE_OFF     0x066A

void createTable()
{
	char  bitpattern[50];
	FILE *table;
	int   bplen;
	int   curnode = 0;
	int   curoff;
	int   findnode = 0;
	int   i;
	int   searching;
	int   testleft;
	int   testnode;
	int   testright;

	table = fopen("fe6.bit", "wb");
	if(!table)
		return;

    curnode = findnode;
	memset(bitpattern, '\0', 50);

	while(findnode < NODE_OFF)
	{
		if(curnode == findnode) // print character we're looking for
			fprintf(table, "%c%c", rom[CHARTBL_START + (findnode * 4)], rom[CHARTBL_START + (findnode * 4) + 1]);
		searching = 1;
		testnode = NODE_OFF - 1;
		curoff = 0;
		//find pointer to this node
		while(searching)
		{
			testnode++;

			if(((testnode - NODE_OFF) * 4) + HEADER_START >= HEADER_END)
			{
				testnode = 0;
				break;
			}

			testleft = rom[curoff++];
			testleft += rom[curoff++] << 8;
			testright = rom[curoff++];
			testright += rom[curoff++] << 8;

			if(testleft == curnode)
				strcat(bitpattern, "0");
			else if(testright == curnode)
				strcat(bitpattern, "1");
			if((testleft == curnode) || (testright == curnode))
				searching = 0;

		}
		if(testnode == 0) //finished that character
		{
			bplen = (int)strlen(bitpattern);
			for(i = 0; i < 50; i++)
			{
				if(i < bplen)
					fprintf(table, "%c", bitpattern[bplen - i - 1]);
				else
					fputc('\0', table);
			}
			findnode++;
		}
		else
		{
            curnode = testnode;
			continue;
		}
		curnode = findnode;
		memset(bitpattern, '\0', 50);
	}

	fclose(table);
}